#ifndef __PAY_OFF_CPP
#define __PAY_OFF_CPP

#include "payoff.h"

PayOff::PayOff() {}

// ==========
// PayOffCall
// ==========

// Constructor with single strike parameter
PayOffCall::PayOffCall(const DCO_T<double>& _K) { K = _K; }

// Over-ridden operator() method, which turns PayOffCall into a function object
DCO_T<double> PayOffCall::operator() (const DCO_T<double>& S) const {
  using namespace std;
  return max(S-K, 0.0); // Standard European call pay-off
}

// =========
// PayOffPut
// =========

// Constructor with single strike parameter
PayOffPut::PayOffPut(const DCO_T<double>& _K) {
  K = _K;
}

// Over-ridden operator() method, which turns PayOffPut into a function object
DCO_T<double> PayOffPut::operator() (const DCO_T<double>& S) const {
  using namespace std;
  return max(K-S, 0.0); // Standard European put pay-off
}

#endif
