# Vector Tangent AD with dco/c++

## DCO_T.h

* `#pragma once`
* `#include "dco.hpp"`
* `template<typename DCO_VT, int N=9>
using DCO_M=dco::gt1v<DCO_VT,N>;`
* `template<typename DCO_VT>
using DCO_T=typename DCO_M<DCO_VT>::type;`

## Preprocessing

* `#include "DCO_T.h"`
* globally search and replace `double` with `DCO_T<double>`
* heston_mc.cpp, payoff.cpp: `using namespace std;` to facilitate overloading of `std::max` outside of standard namespace

## Driver

* main.cpp: 
  *  ...
  * `std::vector<DCO_T<double>*> X={&S_0,&K,&r,&v_0,&T,&rho,&kappa,&theta,&xi};`
  * `for (size_t i=0;i<X.size();i++) dco::derivative(*X[i])[i]=1;`
  *  ...
  * `for (size_t i=0;i<X.size();i++)
    std::cout << dco::derivative(option_price)[i] << ' ';`
  *  ...
