#ifndef __PAY_OFF_HPP
#define __PAY_OFF_HPP

#include "DCO_T.h"

#include <algorithm> // This is needed for the std::max comparison function, used in the pay-off calculations

class PayOff {
 public:
  PayOff(); // Default (no parameter) constructor
  virtual ~PayOff() {}; // Virtual destructor

  // Overloaded () operator, turns the PayOff into an abstract function object
  virtual DCO_T<double> operator() (const DCO_T<double>& S) const = 0;
};

class PayOffCall : public PayOff {
 private:
  DCO_T<double> K; // Strike price

 public:
  PayOffCall(const DCO_T<double>& K_);
  virtual ~PayOffCall() {};

  // Virtual function is now over-ridden (not pure-virtual anymore)
  virtual DCO_T<double> operator() (const DCO_T<double>& S) const;
};

class PayOffPut : public PayOff {
 private:
  DCO_T<double> K; // Strike

 public:
  PayOffPut(const DCO_T<double>& K_);
  virtual ~PayOffPut() {};
  virtual DCO_T<double> operator() (const DCO_T<double>& S) const;
};

#endif
