# early linearization (using dco::jacobian_preaccumulator_t)

## Preprocessing

* `#include "DCO_T.h"`
* globally search and replace `double` with `DCO_T<double>`
* heston_mc.cpp, payoff.cpp: `using namespace std;` to facilitate overloading of `std::max` outside of standard namespace

## Driver

* main.cpp: 
  *  ...
  * for convenience: `std::vector<DCO_T<double>*> X={&S_0,&K,&r,&v_0,&T,&rho,&kappa,&theta,&xi};`
  * `dco::smart_tape_ptr_t<dco_mode<double>> tape;`
  * `for (const auto& x:X) tape->register_variable(*x);`
  *  ...
  * `dco_mode<double>::jacobian_preaccumulator_t jp(tape);`
  * `for (unsigned i=0; i<num_sims; i++) {`
    * `jp.start();`
    *  ...
    * `jp.register_output(payoff_sum);`
    * `jp.finish();`
  * `}`
  *  ...
  * `tape->register_output_variable(option_price);`
  * `dco::derivative(option_price)=1;`
  * `tape->interpret_adjoint();`
  * `for (const auto& x:X) std::cout << dco::derivative(*x) << ' ';`

* compile with `-DDCO_SQRT_AVOID_DIVZERO` eliminate `-nan`
