#ifndef __CORRELATED_SND_H
#define __CORRELATED_SND_H

#include "DCO_T.h"

#include "statistics.h"

class CorrelatedSND : public StandardNormalDistribution {
 protected:
  DCO_T<double> rho;
  const std::vector<DCO_T<double>>* uncorr_draws;

  // Modify an uncorrelated set of distribution draws to be correlated
  virtual void correlation_calc(std::vector<DCO_T<double>>& dist_draws);     

 public:
  CorrelatedSND(const DCO_T<double> _rho, 
                const std::vector<DCO_T<double>>* _uncorr_draws);
  virtual ~CorrelatedSND();

  // Obtain a sequence of correlated random draws from another set of SND draws
  virtual void random_draws(const std::vector<DCO_T<double>>& uniform_draws,
                            std::vector<DCO_T<double>>& dist_draws);
};

#endif 
