// Uwe.Naumann@nag.com

#pragma once
#include <vector>
#include <random>
#include <cmath>
using namespace std; // sorry ...

template <typename T>
T f(int np, int ns, T x, const vector<T>& p) {
  default_random_engine g; normal_distribution<float> d(0,1);
  T y=0, x_in=x; 
  for (int i=0;i<np;++i) {
    x=x_in;
    for (int j=0;j<ns;++j) 
      x+=exp(-p[j]*x)/ns+p[ns+j]*x*sqrt(1./ns)*d(g);
    y+=x;
  }
  return y/np;
}
