// Uwe.Naumann@nag.com

#include "f.h" 

#include <cassert>
#include <limits>
#include <iostream>

int main(int argc, char* argv[]) {
  using namespace std;
  assert(argc==3); 
  int np=stoi(argv[1]), ns=stoi(argv[2]); 
  using T=double; 
  T x=1.; 
  vector<T> p(2*ns,1);
  // dydx
  T eps=numeric_limits<T>::epsilon();
  T h= (x!=0) ? sqrt(eps)*fabs(x) : sqrt(eps);
  T yp=f(np,ns,x+h,p); T ym=f(np,ns,x-h,p); 
  cout.precision(numeric_limits<T>::digits10);
  cout << "dy/dx=" << (yp-ym)/(2*h) << '\n';

  for (int i=0;i<2*ns;++i) {
    h= (p[i]!=0) ? sqrt(eps)*fabs(p[i]) : sqrt(eps);
    T aux=p[i]; 
    p[i]+=h; yp=f(np,ns,x,p); p[i]=aux;
    p[i]-=h; ym=f(np,ns,x,p); p[i]=aux;
    cout << "dy/dp[" << i << "]=" << (yp-ym)/(2*h) << '\n';
  }
  cout << "y=" << f(np,ns,x,p) << endl;
  return 0;
}
