// Uwe.Naumann@nag.com

#include "f.h" 

#include "dco.hpp" 

int main(int argc, char* argv[]) {
  using namespace std;
  assert(argc==3);
  int np=stoi(argv[1]), ns=stoi(argv[2]); 

  using dco_value_type=double;
  using dco_type=dco::gt1s<dco_value_type>::type;

  dco_type x=1.;
  vector<dco_type> p(2*ns,1);

  dco::derivative(x)=1;
  dco_type y=f(np,ns,x,p); 
  dco::derivative(x)=0;
  cout.precision(numeric_limits<dco_value_type>::digits10);
  cout << "dy/dx=" << dco::derivative(y) << '\n';

  for (int i=0;i<2*ns;++i) { 
    dco::derivative(p[i])=1; 
    y=f(np,ns,x,p); 
    dco::derivative(p[i])=0; 
    cout << "dy/dp[" << i << "]=" << dco::derivative(y) << '\n';
  }

  cout << "y=" << dco::value(y) << endl;

  return 0;
}
