// Uwe.Naumann@nag.com

#include "f.h" 

#include "dco.hpp" 

int main(int argc, char* argv[]) {
  using namespace std;
  assert(argc==3); 
  int np=stoi(argv[1]), ns=stoi(argv[2]); 

  using dco_value_type=double;
  const int VECTOR_SIZE=21; assert(VECTOR_SIZE>=2*ns+1);
  using dco_type=dco::gt1v<dco_value_type,VECTOR_SIZE>::type;

  dco_type x=1,y; 
  vector<dco_type> p(2*ns,1);

  dco::derivative(x)[0]=1;
  for (int i=0;i<2*ns;++i) { 
    dco::derivative(p[i])[i+1]=1; 
  }

  y=f(np,ns,x,p); 

  cout.precision(numeric_limits<dco_value_type>::digits10);
  cout << "dy/dx=" << dco::derivative(y)[0] << '\n';
  for (int i=0;i<2*ns;++i)  
    cout << "dy/dp[" << i << "]=" << dco::derivative(y)[i+1] << '\n';

  cout << "y=" << dco::value(y) << endl;

  return 0;
}
