// Uwe.Naumann@nag.com

#include "f.h"

#include "my_dco.h" 

int main() {
  vector<dco_type> x_in(2,-1),x(2);
  dco::smart_tape_ptr_t<dco_mode> tape; 

  tape->register_variable(x_in); 
  x=x_in;
  F(x); 
  tape->register_output_variable(x); 
  inspect(tape,"after recording");

  dco::derivative(x[0])=1; 
  tape->interpret_adjoint(); 
  inspect(tape,"after interpretation");

  cout.precision(numeric_limits<dco_value_type>::digits10); 
  cout << "dx[0]/dx_in[0]=" << dco::derivative(x_in[0]) << '\n';
  cout << "dx[0]/dx_in[1]=" << dco::derivative(x_in[1]) << '\n';
  cout << "x[0]=" << dco::value(x[0]) << '\n';
  cout << "x[1]=" << dco::value(x[1]) << endl;

  return 0;
}
